from typing import Any, Iterable

from tcod.context import Context
from tcod.console import Console

from entity import Entity

class Engine:
	def __init__(self):
		from event_handler import EventHandler
		self.event_handler = EventHandler(self)

		self.player = Entity(0, 0, "@", (255, 255, 255))

	def handle_events(self, events: Iterable[Any]) -> None:
		for event in events:
			action = self.event_handler.dispatch(event)

			if action is None:
				continue
			
			action.apply(Engine)
	
	def render(self, context: Context, console: Console) -> None:
		#TODO: render map

		#TODO: render entities
		# for entity in self.entities:
		# 	console.print(entity.x, entity.y, entity.char, fg=entity.color)

		console.print(self.player.x, self.player.y, self.player.char, fg=self.player.color)

		#send to the screen
		context.present(console)
		console.clear()
